import { IServiceFactory } from '../interface';
export declare const DEFAULT_PRIORITY: {
    L1: string;
    L2: string;
    L3: string;
};
/**
 * 多客户端工厂实现
 */
export declare abstract class ServiceFactory<T> implements IServiceFactory<T> {
    protected clients: Map<string, T>;
    protected priority: any;
    protected options: {};
    protected initClients(options?: any): Promise<void>;
    get<U = T>(id?: string): U;
    has(id: string): boolean;
    createInstance(config: any, clientName?: any): Promise<T | undefined>;
    abstract getName(): string;
    protected abstract createClient(config: any, clientName: any): Promise<T | void> | (T | void);
    protected destroyClient(client: T): Promise<void>;
    stop(): Promise<void>;
    getDefaultClientName(): string;
    getClients(): Map<string, T>;
    getClientKeys(): string[];
    getClientPriority(clientName: string): any;
    isHighPriority(clientName: string): boolean;
    isMediumPriority(clientName: string): boolean;
    isLowPriority(clientName: string): boolean;
}
//# sourceMappingURL=serviceFactory.d.ts.map